VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   0  'None
   ClientHeight    =   2985
   ClientLeft      =   120
   ClientTop       =   120
   ClientWidth     =   3540
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2985
   ScaleWidth      =   3540
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture1 
      AutoSize        =   -1  'True
      Height          =   1185
      Left            =   960
      Picture         =   "Form1.frx":0000
      ScaleHeight     =   1125
      ScaleWidth      =   1500
      TabIndex        =   0
      Top             =   720
      Width           =   1560
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Developped by Yves Geltmeyer on January 2004. Use this code freely."
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Index           =   1
      Left            =   180
      TabIndex        =   2
      Top             =   2280
      Width           =   3135
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Left-lick on form to move it, grab its borders to resize it, right-click for menu"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   435
      Index           =   0
      Left            =   60
      TabIndex        =   1
      Top             =   180
      Width           =   3435
   End
   Begin VB.Menu mnuMenu 
      Caption         =   "Menu"
      Visible         =   0   'False
      Begin VB.Menu mnuExit 
         Caption         =   "&Exit"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'**********************************************************************************
' Borderless Form Move & Resize routines.
' Using a minimal set of Windows API.
'**********************************************************************************
' Made by Yves Geltmeyer (yge@blubay.com) on January 2004
'**********************************************************************************
' Please, use this code freely even for commercial use.
'
' NOTE
' ----
' Remove the menu (used only for sample purpose) to remove the form black border
'**********************************************************************************

Option Explicit

' Windows structure and API declarations
Private Type POINTAPI
    X As Long
    Y As Long
End Type

Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function SetCursorPos Lib "user32" (ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer

' Local constants and variables declarations
Const BorderPixels = 5
Private TwipX As Single, TwipY As Single, BorderWidth As Single, BorderHeight As Single

Private Sub Form_Load()
    ' TwipX and TwipY used only for easier writing
    TwipX = Screen.TwipsPerPixelX
    TwipY = Screen.TwipsPerPixelY
    
    ' Following variables used to speed-up the process (prevent recalc of BorderPixels * ...)
    BorderWidth = BorderPixels * TwipX
    BorderHeight = BorderPixels * TwipY
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim RLeft As Single, RTop As Single, RRight As Boolean, RBottom As Boolean
    Dim StartX As Single, StartY As Single, MX As Single, MY As Single
        
    If Button And vbLeftButton Then
        ' Read the mouse pointer screen position on the beginning
        GetMouseXY StartX, StartY
        ' We don't use the X,Y arguments which are incorect when MouseDown event called
        ' from other screen objects (like Label1 and Image1 hereunder)
        X = StartX - Left
        Y = StartY - Top
        
        ' Flags indicating "from where" the form is being resized
        RLeft = IIf(X < BorderWidth, Width, 0)
        RTop = IIf(Y < BorderHeight, Height, 0)
        RRight = (X > Width - BorderWidth)
        RBottom = (Y > Height - BorderHeight)
        
        ' Place the mouse pointer on the form border for more accuracy
        If RLeft Then SetMouseXY Left, Top + Y
        If RTop Then SetMouseXY Left + X, Top
        If RRight Then SetMouseXY Left + Width, Top + Y
        If RBottom Then SetMouseXY Left + X, Top + Height
        
        ' Save the mouse pointer screen position on the beginning in variables
        GetMouseXY StartX, StartY
        ' While left mouse button is pressed
        While GetAsyncKeyState(vbLeftButton) < 0
            ' Read the actual mouse pointer screen position
            GetMouseXY MX, MY
            
            If RRight Or RLeft Or RBottom Or RTop Then      ' If the form is resized (not moved)
                If RLeft And RLeft + StartX - MX > BorderWidth * 2 Then Move MX, Top, RLeft + StartX - MX
                If RTop And RTop + StartY - MY > BorderHeight * 2 Then Move Left, MY, Width, RTop + StartY - MY
                If RRight And MX - Left > BorderWidth * 2 Then Width = MX - Left
                If RBottom And MY - Top > BorderHeight * 2 Then Height = MY - Top
            Else                                            ' If the form is moved (not resized)
                MousePointer = vbSizeAll                    ' Sets the mouse cursor showing move
                Move MX - X, MY - Y                         ' Actually moves the form on screen
            End If
            DoEvents                                        ' To allow Windows painting events
        Wend
    ElseIf Button And vbRightButton Then
        PopupMenu mnuMenu
    End If
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ' Reset the mouse cursor when left mouse button is not pressed
    If GetAsyncKeyState(vbLeftButton) >= 0 Then MousePointer = 0
    ' Set the correct mouse cursor according to its position on the form
    If X > Width - BorderWidth Or X < BorderWidth Then MousePointer = vbSizeWE
    If Y > Height - BorderHeight Or Y < BorderHeight Then MousePointer = vbSizeNS
    If (X > Width - BorderWidth And Y > Height - BorderHeight) Or (X < BorderWidth And Y < BorderHeight) Then MousePointer = vbSizeNWSE
    If (X > Width - BorderWidth And Y < BorderHeight) Or (X < BorderWidth And Y > Height - BorderHeight) Then MousePointer = vbSizeNESW
End Sub

' Reads actual mouse pointer screen position and convert it to TWIP scale
Private Sub GetMouseXY(X As Single, Y As Single)
    Dim lpPoint As POINTAPI

    GetCursorPos lpPoint
    X = lpPoint.X * TwipX
    Y = lpPoint.Y * TwipY
End Sub

' Places mouse pointer on given screen position given in TWIP scale
Private Sub SetMouseXY(ByVal X As Single, ByVal Y As Single)
    SetCursorPos X / TwipX, Y / TwipY
End Sub

Private Sub Label1_MouseDown(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    Form_MouseDown Button, Shift, X, Y      ' Send the event to underlying form
End Sub

Private Sub Picture1_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Form_MouseDown Button, Shift, X, Y      ' Send the event to underlying form
End Sub

Private Sub mnuExit_Click()
    End
End Sub
